Bug 1131264 - Backport x86/retpolines: Disable switch jump tables when retpolines are enabled (a9d57ef15cbe327fe54416dd194ee0ea66ae53a4)
Backport x86/retpolines: Disable switch jump tables when retpolines are enabl...
Status: RESOLVED FIXED
Classification: openSUSE
Product: openSUSE Tumbleweed
Classification: openSUSE
Component: Kernel
Current
Other Other
: P5 - None : Normal (vote)
: ---
Assigned To: Martin Liška
E-mail List
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2019-04-02 10:36 UTC by Martin Liška
Modified: 2022-07-26 15:21 UTC (History)
8 users (show)

See Also:
Found By: ---
Services Priority:
Business Priority:
Blocker: ---
Marketing QA Status: ---
IT Deployment: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Martin Liška 2019-04-02 10:36:52 UTC
Please backport the revision into all Linux code streams where we have retpolines enabled. Some micro-benchmark numbers can be seen here:
https://gcc.gnu.org/bugzilla/show_bug.cgi?id=86952#c21
Comment 2 Martin Liška 2019-04-11 10:26:26 UTC
I'm going to backport the GCC patch into gcc7 and gcc48 packages that are used by SLE12 and SLE15.
Comment 5 Swamp Workflow Management 2019-04-24 14:20:25 UTC
This is an autogenerated message for OBS integration:
This bug (1131264) was mentioned in
https://build.opensuse.org/request/show/697512 Factory / gcc7
Comment 6 Andreas Taschner 2019-04-25 12:00:41 UTC
Would it be correct to expect that the next kernel updates for SLE 12 and 15 will be built with compilers that have this change in place ? 
Or will it only be those, who get released after the fix for this bug has been released in MUs ?
Or .. ?
Comment 7 Marcus Meissner 2019-04-25 15:13:28 UTC
The ones we release after these updates are released.

I am not sure if we can meet the timeline for the next kernel updates.
Comment 8 Swamp Workflow Management 2019-04-30 13:12:50 UTC
SUSE-RU-2019:1104-1: An update that has one recommended fix can now be installed.

Category: recommended (moderate)
Bug References: 1131264
CVE References: 
Sources used:
SUSE OpenStack Cloud 7 (src):    gcc48-4.8.5-31.20.1
SUSE Linux Enterprise Workstation Extension 12-SP4 (src):    libgcj48-4.8.5-31.20.1
SUSE Linux Enterprise Workstation Extension 12-SP3 (src):    libgcj48-4.8.5-31.20.1
SUSE Linux Enterprise Software Development Kit 12-SP4 (src):    gcc48-4.8.5-31.20.1, libffi48-4.8.5-31.20.1, libgcj48-4.8.5-31.20.1
SUSE Linux Enterprise Software Development Kit 12-SP3 (src):    gcc48-4.8.5-31.20.1, libffi48-4.8.5-31.20.1, libgcj48-4.8.5-31.20.1
SUSE Linux Enterprise Server for SAP 12-SP2 (src):    gcc48-4.8.5-31.20.1
SUSE Linux Enterprise Server for SAP 12-SP1 (src):    gcc48-4.8.5-31.20.1
SUSE Linux Enterprise Server 12-SP4 (src):    gcc48-4.8.5-31.20.1
SUSE Linux Enterprise Server 12-SP3 (src):    gcc48-4.8.5-31.20.1
SUSE Linux Enterprise Server 12-SP2-LTSS (src):    gcc48-4.8.5-31.20.1
SUSE Linux Enterprise Server 12-SP2-BCL (src):    gcc48-4.8.5-31.20.1
SUSE Linux Enterprise Server 12-SP1-LTSS (src):    gcc48-4.8.5-31.20.1
SUSE Linux Enterprise Server 12-LTSS (src):    gcc48-4.8.5-31.20.1
SUSE Linux Enterprise Desktop 12-SP4 (src):    gcc48-4.8.5-31.20.1, libgcj48-4.8.5-31.20.1
SUSE Linux Enterprise Desktop 12-SP3 (src):    gcc48-4.8.5-31.20.1, libgcj48-4.8.5-31.20.1
SUSE Enterprise Storage 4 (src):    gcc48-4.8.5-31.20.1

NOTE: This line indicates an update has been released for the listed product(s). At times this might be only a partial fix. If you have questions please reach out to maintenance coordination.
Comment 9 Swamp Workflow Management 2019-04-30 13:14:12 UTC
SUSE-RU-2019:1105-1: An update that has 6 recommended fixes can now be installed.

Category: recommended (moderate)
Bug References: 1084842,1114592,1124644,1128794,1129389,1131264
CVE References: 
Sources used:
SUSE Linux Enterprise Module for Open Buildservice Development Tools 15 (src):    cross-arm-gcc7-7.4.1+r270528-4.6.1, cross-arm-none-gcc7-bootstrap-7.4.1+r270528-4.6.1, cross-avr-gcc7-bootstrap-7.4.1+r270528-4.6.1, cross-epiphany-gcc7-bootstrap-7.4.1+r270528-4.6.1, cross-hppa-gcc7-7.4.1+r270528-4.6.1, cross-i386-gcc7-7.4.1+r270528-4.6.1, cross-m68k-gcc7-7.4.1+r270528-4.6.1, cross-mips-gcc7-7.4.1+r270528-4.6.1, cross-ppc64-gcc7-7.4.1+r270528-4.6.1, cross-rx-gcc7-bootstrap-7.4.1+r270528-4.6.1, cross-sparc-gcc7-7.4.1+r270528-4.6.1, cross-sparc64-gcc7-7.4.1+r270528-4.6.1, gcc7-7.4.1+r270528-4.6.1, gcc7-testresults-7.4.1+r270528-4.6.1
SUSE Linux Enterprise Module for Development Tools 15 (src):    cross-nvptx-gcc7-7.4.1+r270528-4.6.1, gcc7-7.4.1+r270528-4.6.1
SUSE Linux Enterprise Module for Basesystem 15 (src):    gcc7-7.4.1+r270528-4.6.1

NOTE: This line indicates an update has been released for the listed product(s). At times this might be only a partial fix. If you have questions please reach out to maintenance coordination.
Comment 10 Martin Liška 2019-04-30 13:19:31 UTC
I'm closing that as fixed.
Comment 11 Borislav Petkov 2019-04-30 13:49:35 UTC
(In reply to Martin Liška from comment #10)
> I'm closing that as fixed.

Did the commit get backported to our kernels? I don't see it...
Comment 12 Martin Liška 2019-04-30 13:52:33 UTC
No, but as Jiri Kosina suggested, we backported the disablement at GCC side into SLE 12 and SLE 15 gcc compilers.
Comment 13 Swamp Workflow Management 2019-05-20 16:10:11 UTC
openSUSE-RU-2019:1409-1: An update that has one recommended fix can now be installed.

Category: recommended (moderate)
Bug References: 1131264
CVE References: 
Sources used:
openSUSE Leap 42.3 (src):    cross-aarch64-gcc48-icecream-backend-4.8.5-41.1, cross-armv6hl-gcc48-icecream-backend-4.8.5-41.1, cross-armv7hl-gcc48-icecream-backend-4.8.5-41.1, cross-i386-gcc48-icecream-backend-4.8.5-41.1, cross-ia64-gcc48-icecream-backend-4.8.5-41.1, cross-ppc-gcc48-icecream-backend-4.8.5-41.1, cross-ppc64-gcc48-icecream-backend-4.8.5-41.1, cross-ppc64le-gcc48-icecream-backend-4.8.5-41.1, cross-s390-gcc48-icecream-backend-4.8.5-41.1, cross-s390x-gcc48-icecream-backend-4.8.5-41.1, gcc48-4.8.5-41.1, gcc48-testresults-4.8.5-41.1, libffi48-4.8.5-41.1, libgcj48-4.8.5-41.1
Comment 14 Swamp Workflow Management 2019-05-20 16:11:38 UTC
openSUSE-RU-2019:1415-1: An update that has 6 recommended fixes can now be installed.

Category: recommended (moderate)
Bug References: 1084842,1114592,1124644,1128794,1129389,1131264
CVE References: 
Sources used:
openSUSE Leap 15.0 (src):    gcc7-7.4.1+r270528-lp150.9.2
Comment 15 Andreas Taschner 2019-06-18 08:48:05 UTC
Is it possible to establish whether yesterday's wave of SLE 12+ kernels have been compiled with this optimization in place ?
Comment 17 Marcus Meissner 2019-07-01 08:43:09 UTC
We built all kernels with the newer gcc that optimize better when retpolines are enabled, yes.
Comment 18 Nicola Di Marzo 2019-08-07 16:30:34 UTC
I am following up on this bug on Ericsson's behalf since customer asked to confirm if latest 12 SP2 LTSS kernel version now includes this optimization referenced in this bugzilla

However, there does not seem to be any reference about it in the kernel changelog.

and neither looking at the kernel config:

strings boot/vmlinuz-4.4.121-92.117-default | grep gcc | grep version
4.4.121-92.117-default (geeko@buildhost) (gcc version 4.8.5 (SUSE Linux) ) #1 SMP Tue Jul 9 10:25:00 UTC 2019 (c78052b)

Can you please cofirm that the latest 12 SP2 LTSS kernel has been built with this optimization can also the changelog be updated as well.
Comment 19 Swamp Workflow Management 2019-08-21 13:11:41 UTC
openSUSE-RU-2019:1982-1: An update that has 6 recommended fixes can now be installed.

Category: recommended (moderate)
Bug References: 1084842,1114592,1124644,1128794,1129389,1131264
CVE References: 
Sources used:
openSUSE Leap 15.1 (src):    gcc7-7.4.1+r270528-lp151.2.3.1